package edu.upvehu.gbg.mastermate2425;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author german.bordel@ehu.es
 */
public class DemoControl implements ActionListener {

    private final DemoGUI elGui;
    private Connection conexion;

    public DemoControl(DemoGUI elGui, String dbServer, String databaseName, String usuario, String contrasenia) {
       this.elGui=elGui;
       try{ conexion = DriverManager.getConnection(dbServer+databaseName, usuario, contrasenia);
         } catch (SQLException ex) {
          elGui.errorMessaqe( "<html>"+ex.getMessage()+"<br>No hay conexión con la base de datos");
        }
    
    
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (conexion==null)  {
            elGui.errorMessaqe("No hay conexión con una base de datos");
            return;
        }
        try {
            ResultSet respuesta = conexion.createStatement().executeQuery(elGui.getQuery());
            ResultSetMetaData rsmd=respuesta.getMetaData();
            int numeroColumnas = rsmd.getColumnCount();
            String[] encabezados = new String[numeroColumnas];
            for (int i = 1; i <= numeroColumnas; i++) 
                encabezados[i - 1] = rsmd.getColumnName(i);
             // Obtener los datos de las celdas
            List<String[]> filas = new ArrayList<>();
            while (respuesta.next()) {
                String[] fila = new String[numeroColumnas];
                for (int i = 1; i <= numeroColumnas; i++) {
                    fila[i - 1] = respuesta.getString(i);
                }
                filas.add(fila);
            }
            // Convertir ArrayList a String[][]
            String[][] celdas = new String[filas.size()][numeroColumnas];
            celdas=filas.toArray(new String[0][0]); 
            elGui.setAnswer(celdas, encabezados);
        } catch (SQLException ex) {
            elGui.errorMessaqe(ex.getMessage());
        }
    
    
    }

    boolean conectado() {
        return conexion!=null;
    }





    
}
