package edu.upvehu.gbg.mastermate2425;

import java.io.File;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author german.bordel@ehu.es
 */
public class DemoGUI extends javax.swing.JFrame {

    private final String dbServer;
    private String databaseName;
    private final String usuario;
    private final String contrasenia;
    private DemoControl elControl;

    /**
     * Creates new form DemoGUI
     */
    public DemoGUI(String dbServer, String defaultDatabase, String usuario, String contrasenia) {
        this.dbServer=dbServer;
        this.usuario=usuario;
        this.contrasenia=contrasenia;        
        initComponents();
        setVisible(true);
        useDB(defaultDatabase);
    }
    
    private void useDB(String databaseName){
        this.databaseName=databaseName;
        if (elControl!=null) botonEnviar.removeActionListener(elControl);
        elControl=new DemoControl(this, dbServer, databaseName, usuario, contrasenia);
        if (elControl.conectado()) botonEnviar.addActionListener(elControl);
        databaseNameLabel.setText("Base de datos: " + (elControl.conectado() ? databaseName: "<desconectado>"));
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        query = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        databaseNameLabel = new javax.swing.JLabel();
        botonEnviar = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tablaRespuesta = new javax.swing.JTable();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel1.setLayout(new java.awt.BorderLayout());

        query.setColumns(20);
        query.setRows(5);
        jScrollPane2.setViewportView(query);

        jPanel1.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        jPanel2.add(databaseNameLabel);

        botonEnviar.setText("Enviar consulta");
        jPanel2.add(botonEnviar);

        jPanel1.add(jPanel2, java.awt.BorderLayout.SOUTH);

        jSplitPane1.setLeftComponent(jPanel1);

        tablaRespuesta.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jScrollPane1.setViewportView(tablaRespuesta);

        jPanel3.add(jScrollPane1);

        jSplitPane1.setRightComponent(jPanel3);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jMenu1.setText("DB");

        jMenuItem1.setText("Use DB");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuItem4.setText("Guardar tabla");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem4);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Consultas");

        jMenuItem2.setText("Tablas");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuItem3.setText("Estructura");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem3);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
           String input = JOptionPane.showInputDialog(this,
                "Indique el nombre de la base de datos:",
                "Entrada de Texto",
                JOptionPane.QUESTION_MESSAGE);
        if (input != null) useDB(input);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
       query.setText("show tables");
       botonEnviar.doClick();
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
              query.setText(
                  "SELECT \n"
                + "    TABLE_NAME AS 'Tabla',\n"
                + "    COLUMN_NAME AS 'Columna',\n"
                + "    COLUMN_TYPE AS 'Tipo',\n"
                + "    IS_NULLABLE AS 'Puede ser Nulo',\n"
                + "    COLUMN_KEY AS 'Clave',\n"
                + "    COLUMN_DEFAULT AS 'Valor por Defecto',\n"
                + "    EXTRA AS 'Extra'\n"
                + "FROM \n"
                + "    information_schema.columns\n"
                + "WHERE \n"
                + "    table_schema = DATABASE()\n"
                + "ORDER BY \n"
                + "    TABLE_NAME, ORDINAL_POSITION;");
        botonEnviar.doClick();
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        //Instanciamos un dialogo para movernos por el sistema de archivos
        JFileChooser fileChooser = new JFileChooser();
        //Hacemos que muestre sólo los ficheros con extensión "txt" (y las carpetas, claro)
        fileChooser.setFileFilter(new FileNameExtensionFilter("Archivos de texto (*.txt)", "txt"));
        //Mostramos el dialogo en modo "salvar" (permite seleccionar un archivo o poner un nombre nuevo)
        int userSelection = fileChooser.showSaveDialog(this);
        //Si no salimos pulsando al botón de confirmación no hacemos nada
        if (userSelection != JFileChooser.APPROVE_OPTION) return;
        
        //Obtenemos del dialogo un objeto que representa al fichero seleccionado
        File fichero=fileChooser.getSelectedFile();
        
        //Si el ususario no la ha puesto la extensión ".txt" cambiamos el objeto File otro que la tenga
        if (!fichero.getAbsolutePath().endsWith(".txt")) fichero = new File(fichero.getAbsolutePath() + ".txt");

        // Comprobarmos si el archivo ya existe
        if (fichero.exists()) {
            int sobreescribir = JOptionPane.showConfirmDialog(this, "El archivo ya existe. ¿Desea sobrescribirlo?", "Confirmar sobrescritura", JOptionPane.YES_NO_OPTION);
            if (sobreescribir != JOptionPane.YES_OPTION)  return; // Si el usuario no desea sobrescribir, salir del método
            }
                
        //Ahora escribimos el TableModel de la tablaRespuesta en el fichero que hemos definido con el dialogo
        try {
            DemoUtil.guardarTablemodelEnDisco(tablaRespuesta.getModel(), fichero);
        } catch (IOException ex) {
            errorMessaqe(ex.getMessage()); //Si algo ha ido mal sacamos el mensaje que trae la excepción en un dialogo
        }
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonEnviar;
    private javax.swing.JLabel databaseNameLabel;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextArea query;
    private javax.swing.JTable tablaRespuesta;
    // End of variables declaration//GEN-END:variables

    void errorMessaqe(String message) {
            JOptionPane.showMessageDialog(this,
                message,
                "Advertencia",
                JOptionPane.WARNING_MESSAGE);
    }

    String getQuery() {
      return query.getText();
    }

    void setAnswer(String[][] celdas, String[] encabezados) {
        tablaRespuesta.setModel(new DefaultTableModel(celdas,encabezados));
    }
}
