package edu.upvehu.gbg.mastermate2425;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.table.TableModel;

/**
 *
 * @author german.bordel@ehu.es
 */
public class DemoUtil {
    
    static void guardarTablemodelEnDisco(TableModel modeloDeDatos, File fichero) throws IOException {
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(fichero))) {
            int numFilas = modeloDeDatos.getRowCount();
            int numColumnas = modeloDeDatos.getColumnCount();

            // Escribimos los encabezados con tabuladores como separadores y paso de linea tras la última columna
            for (int col = 0; col < numColumnas; col++) guardaCelda(writer, modeloDeDatos.getColumnName(col), col==numColumnas-1);

            // Escribimos las filas de la tabla con tabuladores como separadores y paso de linea tras la última columna
            for (int row = 0; row < numFilas; row++) {
                for (int col = 0; col < numColumnas; col++)guardaCelda(writer, modeloDeDatos.getValueAt(row, col), col==numColumnas-1);
                writer.write(modeloDeDatos.getValueAt(row, numColumnas - 1).toString() + '\n');
            }
        }
    }

    private static void guardaCelda(BufferedWriter writer, Object valor, boolean ultimaColumna) throws IOException {
        if (valor!=null) writer.write(valor.toString()); //Si el objeto existe se imprime su representación como String
        writer.write(ultimaColumna? '\n' : '\t'); //Si es última columna se pasa de linea, si no se pone tabulador 
    }
}